#!/usr/bin/perl


################################################
#
# You do not need to modify anything below this line
#
################################################

require "setup.pl";
$demo = 0;

################################################
# Perform subs
################################################

&parse;
&setvars;

################################################
# Parse info sub
################################################

sub parse {
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs) {
	   ($name, $value) = split(/=/, $pair);

	   $value =~ tr/+/ /;
	   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	   $value =~ s/<!--(.|\n)*-->//g;

	   $FORM{$name} = $value;
	}
}

################################################
# Set form variables
################################################

sub setvars {
	$ver = 'WWCnotify v2.3';
	$command = "$ENV{'QUERY_STRING'}";
	($dunsublist, $dunsubemail) = split(/=/, $command);
	$action = $FORM{'action'};
	$choice = $FORM{'choice'};
	$name = $FORM{'name'};
	$email = $FORM{'email'};
	$formfooter = $FORM{'formfooter'};
	$date = `$date_command +"%b %d, %y (%T %Z)"`; chop($date);
	$shortdate = `$date_command +"%b %d, %y"`; chop($shortdate);
	$cgi = "$baseurl/$scriptname";
	$dunsubcgi = "$baseurl/$dunsubscript";
	$list = $FORM{'list'};
	$listlock = "$basepath/$list.lock";
	$lists = "$basepath/lists.txt";
	$listslock = "$basepath/lists.lock";
	$subject = $FORM{'subject'};
	$message = $FORM{'message'};
	undef $Powered;
}

################################################

if ($dunsubemail) {&directunsub;}

if ($email) {&checkemail;}

if ($action) {
	if ($requirename eq '1') {$missing = 'Name';&not_complete unless $name;}
	&checkemail;
	if ($choice eq 'sub') {&add;}
	if ($choice eq 'unsub') {&remove;}
}

if ($command eq $notifyformcommand) {&notifyform;}
elsif ($command eq $shownotifycommand) {&showlistselect;}
elsif ($command eq 'showlistnow') {&showlist;}
elsif ($command eq $shownotifycommand) {&showlist;}
elsif ($command eq 'sendthenotifynow') {&send;}
else
 {
	if ($serverside eq '0') {&header;}
	else {print "Content-type: text/html\n\n";}
	&printnotifyform;
	&PoweredBy;
	$Powered = 1;
	if ($serverside eq '0') {&footer;}
 }

################################################
# sub to add to notify list
################################################

sub add {

	$dup = 0;
	
	if (-e "$list")
	 {
		open (FILE,"$list") || die "Can't open $list!\n";
		@lines=<FILE>;
		close(FILE);
	
		foreach $line (@lines) {    
			&splitlist;
			if ($uemail eq $email) {$dup = '1';}
		}
	 }
	if ($dup eq '0')
	 {
		while (-f $listlock){select(undef,undef,undef,0.1);}
		open(LOCKFILE, ">$listlock");

		open (FILE,">>$list");
		print FILE "$email=$name=$date\n";
		close(FILE);

		close(LOCKFILE);
		unlink($listlock);
	 }

	&printresult;
}

################################################
# Sub to remove from notify list
################################################

sub remove {


	if (-e "$list")
	 {
		open (FILE,"$list") || die "Can't open $list!\n";
		@lines=<FILE>;
		close(FILE);
	
	
		while (-f $listlock){select(undef,undef,undef,0.1);}
		open(LOCKFILE, ">$listlock");
	
		open (FILE,">$list");
		foreach $line (@lines)
		 {
			&splitlist;
			if ($uemail ne $email)
			 {
				print FILE "$uemail=$uname=$udate";
			 }
		 }
		close(FILE);
	
		close(LOCKFILE);
		unlink($listlock);
	 }

	&printresult;
}

################################################
# Split notify list
################################################

sub splitlist {
	($uemail, $uname, $udate) = split(/=/, $line);
}

################################################
# Split the list choices file
################################################

sub splitlists {
	($listfile, $listname) = split(/=/, $line);
	chop $listname;
}

################################################
# Bad email
################################################

sub bademail {
	&header;
	print "<p><strong><font color=red>Bad email address entered!</font></strong></p>\n";
	print "<p>Please ensure email address is in the proper format such as:\n</p>";
	print "<p>name\@domain.com<br>\n";
	print "name\@domain.net<br>\n";
	print "name\@domain.org<br>\n";
	print "and so on...</p>\n";
	print "<p>Hit your browsers <b>back</b> button to return.</p>\n";
	&footer;
	
}

################################################
# Check email correct format
################################################

sub checkemail {
	
	if ( $email !~ /^[\w\-\.\!\%\+]+\@[a-zA-z0-9\-]+(\.[a-zA-Z0-9\-]+)*\.[a-zA-Z0-9\-]+$/ )
	 {
		&bademail;
	 }
}

################################################
# print the header
################################################

sub header {
	print "Content-type: text/html\n\n";

	if ($header) {
		print qq~
			$header
		~;
	}
	else {
		print qq~
			<html><head><title>$title</title></head>
			<body bgcolor="$bgcolor">
			<font face="$fontface" size="$fontsize">
			<center>
			<p><h3>$title<h3></p>
		~;
	}
}

################################################
# print the footer
################################################

sub footer {
	print qq~
		<p><a href="$home">$title</a><br>
		<a href="mailto:$owneremail">$owneremail</a></p>
	~;

	&PoweredBy;
	
	if ($footer) {
		print qq~
			$footer
		~;
	}

exit;

}

################################################
# Powered By 
################################################

sub PoweredBy
 {
	if (!$Powered)
	 {
	 	print qq~
			<center><div align="center">
			<font size="1">
			<p>Powered by <a href="http://www.wolfcountry.com/scripts/notify/">$ver</a></p>
			</font>
			</div></center>
		~;
	 }
 }

################################################
# form not complete sub
################################################

sub not_complete {
	&header;
	print "<p><strong><font color=red>All required fields were not filled in!</font></strong></p>\n";
	print "<p>The field <u>$missing</u> was not filled in!\n";
	print "<p>In order for us to process your request, you must ensure all fields \n";
	print "marked with a <font size=\"+1\" color=red><b>*</b></font> are filled in.</p>\n";
	print "<p>Hit your browsers <b>back</b> button to return.</p>\n";
	&footer;
}


################################################
# Print notify form
################################################

sub printnotifyform {

	print "<form method=\"POST\" action=\"$cgi\">\n";
	print "<table border=0 cellpadding=\"1\">\n";
	print "<tr><td colspan=2><font size=\"-2\">* indicates required field</font></td></tr>\n";
	print "<tr>\n";
	print "<td align=\"right\">";
	if ($requirename eq '1'){print "* ";}
	print "Name: ";
	print "</td>\n";
	print "<td><input type=\"text\" name=\"name\" size=\"30\"></td>\n";
	print "</tr>\n";
	print "<tr>\n";
	print "<td align=\"right\">";
	print "* Email: ";
	print "</td>\n";
	print "<td><input type=\"text\" name=\"email\" size=\"30\"></td>\n";
	print "</tr>\n";

	print "<tr>\n";
	print "<td colspan=2><font size=\"-1\">";
	print "&nbsp;&nbsp;&nbsp;Please select a list below:";
	print "</font></td>\n";
	print "</tr>\n";
	print "<tr>\n";
	print "<td colspan=2 align=\"center\">&nbsp;&nbsp;&nbsp;&nbsp;<select name=\"list\" size=\"1\">\n";

	while (-f $listslock){select(undef,undef,undef,0.1);}
	open(LOCKFILE, ">$listslock");

	open(FILE,"$lists") || die "Can't open $lists!\n";
	@lines = <FILE>;
	close(FILE);

	close(LOCKFILE);
	unlink($listslock);

	foreach $line (@lines) {    
		&splitlists;
		print "<option value=\"$listfile\">$listname</option>\n";
	}

	print "</select></td>\n";
	print "</tr>\n";

	print "<tr><td colspan=2 align=\"center\">&nbsp;&nbsp;&nbsp<input type=\"radio\" value=\"sub\" checked name=\"choice\">Add me \n";
	print "&nbsp;&nbsp;&nbsp;<input type=\"radio\" value=\"unsub\" name=\"choice\"> Remove me </td></tr>\n";
	print "<tr><td colspan=2 align=\"center\">\n";
	print "<input type=\"submit\" value=\"Submit\" name=\"action\"> \n";
	print "<input type=\"reset\" value=\"Reset\" name=\"B2\"></td></tr>\n";
	print "</form>\n";
	print "</table>\n";

}

################################################
# Show select form for notify lists
################################################

sub showlistselect {
	&header;

	print "<form method=\"POST\"  action=\"$cgi?showlistnow\">\n";
	print "<p>List choice: ";
	print "<select name=\"list\" size=\"1\">\n";

	while (-f $listslock){select(undef,undef,undef,0.1);}
	open(LOCKFILE, ">$listslock");

	open(FILE,"$lists") || die "Can't open $lists!\n";
	@lines = <FILE>;
	close(FILE);

	close(LOCKFILE);
	unlink($listslock);

	foreach $line (@lines) {    
		&splitlists;
		print "<option value=\"$listfile\">$listname</option>\n";
	}

	print "</select></p>\n";
	print "<p><input type=\"submit\" value=\"Show list\" name=\"B1\"></p>\n";
	print "</form>\n";

	&footer;


}

################################################
# Show download database
################################################

sub showlist {

	if (-e "$list")
	 {
		open(FILE,"$list") || die "Can't open $list!\n";
		@lines = <FILE>;
		close(FILE);
	 }

	&header;
	print "\n";
	print "<table cellspacing=0 border=1>\n";
	print "<tr><th>Email</th><th>Name</th><th>Date</th></tr>\n";
	foreach $line (@lines) {    
		&splitlist;
		print "<tr><td><font size=\"-1\">$uemail</font></td>\n";
		print "<td><font size=\"-1\">";
		if ($uname) {print "$uname";}else{print "&nbsp;";}
		print "</font></td>";
		print "<td><font size=\"-1\">$udate</font></td></tr>\n";
	}
	print "</table>\n";
	&footer;
}

################################################
# Print result on add/remove notify and no download
################################################

sub printresult {
	&header;
	print "<p><b>Your request has been processed!</b></p>\n";
	print "<p>Thank You!</p>\n";
	&footer;
}

################################################
# Print the notify form
################################################

sub notifyform {

	&header;
	print "<form method=\"POST\"  action=\"$cgi?sendthenotifynow\">\n";
	print "<p align=center><font size=\"5\">Notification Form</font></p>\n";
	print "</center>\n";

	print "<p>List choice: ";
	print "<select name=\"list\" size=\"1\">\n";

	while (-f $listslock){select(undef,undef,undef,0.1);}
	open(LOCKFILE, ">$listslock");

	open(FILE,"$lists") || die "Can't open $lists!\n";
	@lines = <FILE>;
	close(FILE);

	close(LOCKFILE);
	unlink($listslock);

	foreach $line (@lines) {    
		&splitlists;
		print "<option value=\"$listfile\">$listname</option>\n";
	}

	print "</select></p>\n";

	print "<p>Subject:<br><input type=\"text\" name=\"subject\" size=\"60\" value=\"$notifysubject ($shortdate)\"></p>\n";
	print "<p>Please enter any comments below. This will be the main body of the message:<br>\n";
	print "<textarea rows=\"10\" name=\"message\" cols=\"60\"></textarea></p>\n";
	print "<p>Message Footer:<br>\n";
	print "<textarea rows=\"5\" name=\"formfooter\" cols=\"60\">$notifyfooter</textarea></p>\n";
	print "<p><input type=\"submit\" value=\"Send Notify Email\" name=\"B1\">\n";
	print "<input type=\"reset\" value=\"Reset Notify Form\" name=\"B2\"></p>\n";
	print "</form>\n";
	print "<center>\n";
	&footer;
}

################################################
# Send the notify email
################################################

sub send {

	if ($demo != 1)
	 {


		open (FILE,"$lists") || die "Can't open $lists!\n";
		@lines = <FILE>;
		close(FILE);
		
		foreach $line (@lines)
		 {
		 	&splitlists;
		 	if ($listfile eq $list)
		 	 {
				$listtitle = $listname;
				$listtitle =~ s/ /_/g;
		 	 }
		 }

		open (FILE,"$list") || die "Can't open $list!\n";
		@lines = <FILE>;
		close(FILE);
	
		foreach $line (@lines)
		 {
			&splitlist;

			open (MAIL, "|$mailprog $uemail") || die "Can't open $mailprog!\n";
			print MAIL "Reply-to: $owneremail <$owneremail>\n";
			print MAIL "From: $owneremail <$owneremail>\n";
			print MAIL "Subject: $subject\n\n";
			if ($uname) {
				print MAIL "Hello $uname,\n\n";
			}
			else {
				print MAIL "To: $uemail\n\n";
			}
			if ($message) {
				print MAIL "$message\n\n";
			}
			if ($formfooter) {
				print MAIL "$formfooter\n\n";
			}
			$listtitle =~ s/ /_/g;
			print MAIL "Use the link below to directly unsub from this list.\n";
			print MAIL "$cgi?$listtitle=$uemail\n";
			print MAIL "You will get a confirmation if the request is processed correctly.\n";
			close (MAIL);
		 }

	}

	&printresult;
}

################################################
# Unsub through direct link
################################################

sub directunsub {

	while (-f $listslock){select(undef,undef,undef,0.1);}
	open(LOCKFILE, ">$listslock");

	open(FILE,"$lists") || die "Can't open $lists!\n";
	@lines = <FILE>;
	close(FILE);

	close(LOCKFILE);
	unlink($listslock);

	foreach $line (@lines) {    
		&splitlists;
		$dunsublist =~ s/_/ /g;
		if ($dunsublist eq $listname) {
			$list = $listfile;
		}
	}

	$email = $dunsubemail;
	&checkemail;
	&remove;
}

