##############################################################################
# WWCnotify.pl v2.3
# Date: 8/24/99
# http://www.wolfcountry.com/scripts/notify/
#
# Copyright 1997 Troy Sniff
# http://www.wolfcountry.com/
# scripts@wolfcountry.com
##############################################################################
# This script may be used free and modified for your use under the following
# guidelines:
#	* This header must remain intact.
#	* The copyright notice must remain intact.
#	* You do not attemp to sell the code from this script without permission 
#	  from Wolfcountry Web Creations. This includes a modified version.
#	* You agree that Wolfcountry Web Creations is not liable for anything
#	  resulting from it's use.
# 	* You do not redistribute this code without permission 
#	  from Wolfcountry Web Creations.
##############################################################################

###########################################
# Using the Script
###########################################
# You can call the script directly such as:
#
# http://www.domain.com/cgi-bin/WWCnotify/WWCnotiy.pl
#
# or call it through SSI such as:
#
# <!--#exec cgi="/cgi-bin/WWCnotify/WWCnotiy.pl -->
#
# To view your subscribers you will call
# the script in the following format:
#
#     WWCnotify.pl?xxxx
#
# Where xxxx is the value you set for 
# $shownotifycommand below.
#
#
# To send a message, you will call
# the script in the following format:
#
#    WWCnotify.pl?xxxx
#
# Where xxxx is the value you set for 
# $notifyformcommand below.
#
###########################################

###########################################
# CHMOD and setup
###########################################
#
# WWCnotify.pl				755
# setup.pl				755
# lists.txt				666
# All list subscription files		666
#
# Make sure you change the first line of the
# WWCnotify.pl file to reflect the location 
# of your PERL
###########################################

###########################################
#
# Ensure you create a blank file for each new 
# subscription list or you will get errors
# when the script can't find it!
#
# I've included three example lists..
#		list1.txt
#		list2.txt
#		list3.txt
#
# Don't forget to set the permissions for 
# all new lists.
#
###########################################

###########################################
# lists.txt
###########################################
#
# This is the file in which the script pulls the 
# choices of lists from.
#
# The format for this file is:
#
#	filename=ListName
#
# The = sign is a seperator
#
#	Example:
#
#		list1.txt=List Number 1
#
# The lists.txt file has examples in it already.
#
###########################################

###########################################
# Upgrading from v2.0
###########################################
#
# You should use and modify the new 
# setup.pl file since it has slightly 
# changed from previous version.
#
#
# Your lists.txt file can now use spaces 
# for List names
#
#	list1.txt=This is the list name
#
# You no longer have to use "_" for spaces.
#
###########################################
# Upgrading from v1.0
###########################################
#
# rename your notify.txt file or the file you have 
# all of your email addresses in to another name such as list1.txt
#
# Make an entry in the lists.txt file to reflect this and 
# give it a name.  Example:
#
#	list1.txt=This is the name for your list
#
###########################################


#############################################################
# Title of your page
#############################################################

$title = 'WWC Scripts';

#############################################################
# Absolute path to location of data files. Without trailing "/"
# Example: /usr/www/users/tsniff/scripts/notify
#############################################################

$basepath = "/usr/www/users/tsniff/scripts/notify/test";

#############################################################
# Base URL to script. Without trailing "/"
# Example: http://www.wolfcountry.com/scripts/notify
#############################################################

$baseurl = "http://www.wolfcountry.com/scripts/notify/test";

###################################################
# URL of the homepage to return users to
####################################################

$home = 'http://www.wolfcountry.com/scripts/';

#############################################################
# Script filename
#############################################################

$scriptname = "WWCnotify.pl";

#############################################################
# Default background color, text face, text color
#############################################################

$bgcolor = '#FFFFFF';
$fontface = 'arial';
$fontsize = '3';

#############################################################
# Your email address
#############################################################

$owneremail = 'scripts@wolfcountry.com';

#############################################################
# Option to require name
#############################################################

$requirename = 1;			# 1 = Yes; 0 = No

#############################################################
# Set to 1 if you are calling script through server side 
# includes. This prevents the use of the header and footer.
#############################################################

$serverside = 0;			# 1 = Yes; 0 = No

#############################################################
# Commands for viewing update list sending messages to all 
# of those on the update list. Change these to whatever you 
# want.  Preferably something no one would guess
# or they will have access to these functions
# These variable cannot be the same.
#############################################################

$shownotifycommand = 'show';
$notifyformcommand = 'send';

#############################################################
# Header variable.  Allows you to customize the look of your
# script.
# Make sure you place all HTML between the indicated 
# markers below.
#############################################################

$header = qq~
<!-- ### PLACE HTML BELOW THIS LINE ### -->

<html><head><title>This is the customized header</title></head>
<body bgcolor="#FFFFFF">
<font face="arial">
<center>
<p><font size="+3"><strong>Customized Title</strong></font></p>

<!-- ### END OF HTML ### -->
~;

#############################################################
# Header variable.  Allows you to customize the look of your
# script.
# Make sure you place all HTML between the indicated 
# markers below.
#############################################################

$footer = qq~ 
<!-- ### PLACE HTML BELOW THIS LINE ### -->

<p>This is where you put the html for your footer.</p>

<!-- ### END OF HTML ### -->
~;

#############################################################
# Default Subject notify email
#############################################################

$notifysubject = 'WWC Scripts Notify';

#############################################################
# Default footer for the notify email
# Make sure you place all text between the opening "qq~" and 
# the ending "~;". Do not remove these markers.
# HTML should not be used since this is only 
# text to be used in the email.
#############################################################

$notifyfooter = qq~
Wolfcountry Web Creations' Scripts
http://www.wolfcountry.com/scripts
scripts\@wolfcountry.com
~;

#############################################################
# location of your date and mail programs
#############################################################

$date_command = '/bin/date';
$mailprog = '/usr/sbin/sendmail';


1;

